class XC_ImpactEvents expands Info;
 
var ViewPort Player;
var float PushDelta[2];
var vector Vel[2];
var int iPush;

var bool bCurAdj;
var SavedMove CurMove;
var int CurAdj;
var int OldAdj;

event PostBeginPlay()
{
	local PlayerPawn P;
	ForEach AllActors( class'PlayerPawn', P)
		if ( ViewPort(P.Player) != none )
		{
			Player = ViewPort(P.Player);
			break;
		}
	SetLocation( vect(30100, 30100, 30100) );
	SetCollision( true);
}

event Tick( float DeltaTime)
{
	local int j;
	local SavedMove aMove;

	while ( (j<iPush) && (PushDelta[j] < Player.Actor.CurrentTimeStamp) )
		j++;
	if ( j > 0 )
		PopList(j);

	// Prepare player for next frame
	if ( iPush > 0 )
	{
		bCurAdj = false;
		class'sg_TouchUtil'.static.SetTouch( Player.Actor, self);
		class'sg_TouchUtil'.static.SetTouch( self, Player.Actor);
	}
}

event UnTouch( Actor Other)
{
	local byte i;
	if ( Other == Player.Actor )
	{
		if ( Player.Actor.bUpdating )
		{
			if ( !bCurAdj && (iPush > 0)  )
			{
				while ( (i < iPush) && (PushDelta[i] <= Player.Actor.CurrentTimeStamp) )
					i++;
				if ( i > 0 )
					PopList(i);
				CurAdj = 0;
				OldAdj = 0;
				bCurAdj = true;
				CurMove = Player.Actor.SavedMoves; //Player has already cleaned up moves!
				if ( (CurMove != none) && (CurMove.TimeStamp >= PushDelta[0]) ) //Apply first velocity change
				{
					Player.Actor.PendingTouch = self;
					PendingTouch = Player.Actor;
					CurAdj = 1;
				}

			}
			if ( bCurAdj && (CurMove != none) )
				CurMove = CurMove.NextMove;
			if ( (CurMove != none) && (CurAdj < iPush) )
			{
				if ( CurMove.TimeStamp >= PushDelta[CurAdj] )
				{
					Player.Actor.PendingTouch = self;
					PendingTouch = Player.Actor;
					CurAdj++;
				}
			}
		}
		class'sg_TouchUtil'.static.SetTouch( Other, self);
		class'sg_TouchUtil'.static.SetTouch( self, Other);
	}
}

event PostTouch( Actor Other)
{
	local int i;
	if ( Other != Player.Actor )
		return;
	For ( i=OldAdj ; i<=CurAdj ; i++ )
	{
		Player.Actor.Velocity += Vel[i];
		if ( Player.Actor.Physics == PHYS_Walking )
			Player.Actor.SetPhysics( PHYS_Falling);
	}
	OldAdj = CurAdj;
}

function AddNewPush( vector PushVel)
{
	local info I;

	if ( Level.NetMode != NM_Client )
		return;

	if ( iPush < 2 )
	{
		PushDelta[iPush] = Level.TimeSeconds;
		Vel[iPush] = PushVel;
		iPush++;
	}
}

function PopList( int PopCount)
{
	local int i, j;

	assert( iPush > 0 );
	assert( PopCount > 0);
	assert( PopCount <= iPush);
	iPush -= PopCount;
	while ( i < iPush )
	{
		PushDelta[i] = PushDelta[i+PopCount];
		Vel[i] = Vel[i+PopCount];
		i++;
	}
}

defaultproperties
{
    RemoteRole=ROLE_None
    bCollideWorld=False
    bHidden=True
}
